#ifndef AUDIO_H
#define AUDIO_H

/* OC0A */
#define AUDIO_OUTPUT_DDR		DDRD
#define AUDIO_OUTPUT_PORT		PORTD
#define AUDIO_OUTPUT_POS		PD6

/* equal to the sampling rate */
#define AUDIO_INTRS_PER_S		8000

#include <util/delay.h>

#define AUDIO_ERROR_FUNCTION() ;/* { \
	for(uint8_t i = 0; i < 10; ++i) \
	{ \
		PORTD |= 0x80; \
		_delay_ms(100); \
		PORTD &= ~0x80; \
		_delay_ms(100); \
	} \
} */

#define AUDIO_BUFFER_SIZE 200

#include <stdint.h>

void audio_init();

void audio_intr();

uint8_t audio_active();

void audio_stop();

//uint8_t audio_set_buffer(uint8_t* buffer);
uint8_t audio_set_buffer(void);

volatile uint8_t* audio_get_free_buffer(void);

volatile uint8_t* audio_get_buffer(uint8_t num);

#endif /* AUDIO_H */
