#include "ff.h"
#include "lcd.h"
#include "audio.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <string.h>
#include <stdlib.h>

void timer_init(void)
{
	OCR1A = F_CPU / AUDIO_INTRS_PER_S - 1;
	TCCR1B = (1 << WGM12) | (1 << CS10);

	TIMSK1 = (1 << OCIE1A);

	sei();
}

ISR(TIMER1_COMPA_vect)
{
	audio_intr();
}

int main(void)
{
	FATFS fatfs;
	FIL file;
	FRESULT result;
	UINT count;

	timer_init();
	audio_init();

	result = f_mount(&fatfs, "", 0);
	if(result)
	{
		/* error handling */
	}

	result = f_open(&file, "test.wav", FA_READ);
	if(result)
	{
		/* error handling */
	}

	while(1)
	{
		uint8_t* temp;
		do
			temp = audio_get_free_buffer();
		while(temp == NULL);

		result = f_read(&file, temp, AUDIO_BUFFER_SIZE, &count);
		if(result)
		{
			/* error handling */
			break;
		}
		else if(count < 1)
		{
			/* finished */
			break;
		}

		while(!audio_set_buffer())
			;
    }

    /* Close the file */
    f_close(&file);
	audio_stop();

	while(1)
		;

    return 0;
}
